using System;
using System.Collections;

namespace Sudoku
{
	/// <summary>
	/// 
	/// </summary>
	public class CellGroup
	{
		protected Hashtable cells;

		public CellGroup()
		{
			cells = new Hashtable();
		}

		public void Remove(PuzzleCell c)
		{
			foreach (PuzzleCell cell in cells.Values) 
			{
				if (c != cell) 
				{
					cell.Remove(c.CellValue);
				}
			}
		}

		public void Pull(int pullValue) 
		{
			// If pullValue is possible in only one cell, make it certain in that cell.

			PuzzleCell firstPossibility = null;

			foreach (PuzzleCell cell in cells.Values)
			{
				if (cell.IsPossible(pullValue)) 
				{
					if (null == firstPossibility) 
					{
						firstPossibility = cell;
					} 
					else 
					{
						return;
					}
				}
			}

			firstPossibility.MakeCertain(pullValue);
		}
	}
}
