using System;
using System.Collections;

namespace Sudoku
{
	/// <summary>
	/// 
	/// </summary>
	public class PuzzleCell
	{
		protected Hashtable possibilities;
		protected PuzzleBlock block;
		protected PuzzleRow row;
		protected PuzzleColumn column;

		private PuzzleCell(){}

		public PuzzleCell(int initValue)
		{
			possibilities = new Hashtable(9);
			if (0 == initValue) 
			{
				int [] values = {1, 2, 3, 4, 5, 6, 7, 8, 9};
				foreach (int i in values) 
				{
					possibilities.Add(i, i);
				}
			} 
			else 
			{
				possibilities.Add(initValue, initValue);
			}
		}

		public void MakeCertain(int initValue) 
		{
			possibilities = new Hashtable(1);
			possibilities.Add(initValue, initValue);
		}

		public void Remove(int rValue) 
		{
			possibilities.Remove(rValue);
		}

		public bool IsPossible(int checkValue) 
		{
			return (null != possibilities[checkValue]);
		}

		public PuzzleBlock Block
		{
			get
			{
				return block;
			}
			set
			{
				block = value;
			}
		}

		public PuzzleRow Row
		{
			get
			{
				return row;
			}
			set
			{
				row = value;
			}
		}

		public PuzzleColumn Column
		{
			get
			{
				return column;
			}
			set
			{
				column = value;
			}
		}

		public bool IsCertain
		{
			get
			{
				return (1 == possibilities.Count);			
			}
		}

		public int CellValue
		{
			get
			{
				IDictionaryEnumerator e = possibilities.GetEnumerator();
				e.Reset(); e.MoveNext();
				return System.Convert.ToInt32(e.Value);
			}
		}
	}
}
